package com.muyu.domain.data;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.muyu.common.core.annotation.Excel;
import com.muyu.common.core.web.domain.BaseEntity;
import com.muyu.domain.req.MessageDetailEditReq;
import com.muyu.domain.req.MessageDetailQueryReq;
import com.muyu.domain.req.MessageDetailSaveReq;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

/**
 * @ClassDescription:
 * @JdkVersion: 17
 * @Author: zhangxu
 * @Created: 2024/6/26 21:45
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@TableName("message_detail")
@EqualsAndHashCode(callSuper = true)
@ApiModel(value = "MessageDetail", description = "报文详情")
public class MessageDetail extends BaseEntity {

    private static final long serialVersionUID = 1L;

    /** 主键 */
    @TableId(value = "id",type = IdType.AUTO)
    @ApiModelProperty(name = "主键", value = "主键")
    private Long id;

    /** 指标项key */
    @Excel(name = "指标项key")
    @ApiModelProperty(name = "指标项key", value = "指标项key")
    private String messageKey;

    /** 起始位 */
    @Excel(name = "起始位")
    @ApiModelProperty(name = "起始位", value = "起始位")
    private Long startBit;

    /** 终止位 */
    @Excel(name = "终止位")
    @ApiModelProperty(name = "终止位", value = "终止位")
    private Long stopBit;

    /** 指标项标签 */
    @Excel(name = "指标项标签")
    @ApiModelProperty(name = "指标项标签", value = "指标项标签")
    private String label;

    /** 类型 */
    @Excel(name = "类型")
    @ApiModelProperty(name = "类型", value = "类型")
    private String type;

    /**
     * 查询构造器
     */
    public static MessageDetail queryBuild(MessageDetailQueryReq messageDetailQueryReq){
        return MessageDetail.builder()
                .messageKey(messageDetailQueryReq.getMessageKey())
                .startBit(messageDetailQueryReq.getStartBit())
                .stopBit(messageDetailQueryReq.getStopBit())
                .label(messageDetailQueryReq.getLabel())
                .type(messageDetailQueryReq.getType())
                .build();
    }

    /**
     * 添加构造器
     */
    public static MessageDetail saveBuild(MessageDetailSaveReq messageDetailSaveReq){
        return MessageDetail.builder()
                .messageKey(messageDetailSaveReq.getMessageKey())
                .startBit(messageDetailSaveReq.getStartBit())
                .stopBit(messageDetailSaveReq.getStopBit())
                .label(messageDetailSaveReq.getLabel())
                .type(messageDetailSaveReq.getType())
                .build();
    }

    /**
     * 修改构造器
     */
    public static MessageDetail editBuild(Long id, MessageDetailEditReq messageDetailEditReq){
        return MessageDetail.builder()
                .id(id)
                .messageKey(messageDetailEditReq.getMessageKey())
                .startBit(messageDetailEditReq.getStartBit())
                .stopBit(messageDetailEditReq.getStopBit())
                .label(messageDetailEditReq.getLabel())
                .type(messageDetailEditReq.getType())
                .build();
    }



}
