package com.muyu.vehicle.service.Impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.muyu.common.core.utils.StringUtils;
import com.muyu.domain.FaultRecord;


import com.muyu.domain.req.FaultRecordReqVo;
import com.muyu.domain.vo.FaultRecordVo;
import com.muyu.vehicle.mapper.FaultRecordMapper;
import com.muyu.vehicle.service.FaultRecordService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @ClassDescription:
 * @JdkVersion: 17
 * @Author: zhangxu
 * @Created: 2024/6/20 15:22
 */
@Service
@Slf4j
public class FaultRecordServiceImpl extends ServiceImpl<FaultRecordMapper, FaultRecord> implements FaultRecordService {




    @Autowired
    private FaultRecordMapper faultRecordMapper;

    /**
     * 查询故障记录列表
     *
     * @param faultRecord 故障记录
     * @return 故障记录
     */
    @Override
    public List<FaultRecord> list(FaultRecord faultRecord) {
        LambdaQueryWrapper<FaultRecord> queryWrapper = new LambdaQueryWrapper<>();
        if (StringUtils.isNotEmpty(faultRecord.getFaultCode())){
            queryWrapper.eq(FaultRecord::getFaultCode, faultRecord.getFaultCode());
        }

        if (StringUtils.isNotEmpty(faultRecord.getVin())){
            queryWrapper.eq(FaultRecord::getVin, faultRecord.getVin());
    }
        return list(queryWrapper);

    }

    @Override
    public void updateByFaultRecord(FaultRecord build) {
        faultRecordMapper.updateByFaultRecord(build);
    }

    @Override
    public FaultRecord getByFaultRecord(FaultRecord faultRecord) {
        return faultRecordMapper.getByFaultRecord(faultRecord);
    }

    @Override
    public List<FaultRecordVo> countList(FaultRecordReqVo recordReqVo) {
        return faultRecordMapper.countList(recordReqVo);
    }


}
